# 1 "<built-in>"
# 1 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/mulsc3.c"
/* ===-- mulsc3.c - Implement __mulsc3 -------------------------------------===
 *
 *                     The LLVM Compiler Infrastructure
 *
 * This file is dual licensed under the MIT and the University of Illinois Open
 * Source Licenses. See LICENSE.TXT for details.
 *
 * ===----------------------------------------------------------------------===
 *
 * This file implements __mulsc3 for the compiler_rt library.
 *
 * ===----------------------------------------------------------------------===
 */

#if 0 /* expanded by -frewrite-includes */
#include "int_lib.h"
#endif /* expanded by -frewrite-includes */
# 15 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/mulsc3.c"
# 1 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h" 1
/* ===-- int_lib.h - configuration header for compiler-rt  -----------------===
 *
 *                     The LLVM Compiler Infrastructure
 *
 * This file is dual licensed under the MIT and the University of Illinois Open
 * Source Licenses. See LICENSE.TXT for details.
 *
 * ===----------------------------------------------------------------------===
 *
 * This file is a configuration header for compiler-rt.
 * This file is not part of the interface of this library.
 *
 * ===----------------------------------------------------------------------===
 */

#ifndef INT_LIB_H
#define INT_LIB_H

/* Assumption: Signed integral is 2's complement. */
/* Assumption: Right shift of signed negative is arithmetic shift. */
/* Assumption: Endianness is little or big (not mixed). */

#if defined(__ELF__)
#define FNALIAS(alias_name, original_name) \
  void alias_name() __attribute__((alias(#original_name)))
#else
# 27 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
#define FNALIAS(alias, name) _Pragma("GCC error(\"alias unsupported on this file format\")")
#endif
# 29 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"

/* ABI macro definitions */

#if __ARM_EABI__
# define ARM_EABI_FNALIAS(aeabi_name, name)         \
  void __aeabi_##aeabi_name() __attribute__((alias("__" #name)));
# define COMPILER_RT_ABI __attribute__((pcs("aapcs")))
#else
# 37 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
# define ARM_EABI_FNALIAS(aeabi_name, name)
# define COMPILER_RT_ABI
#endif
# 40 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"

#ifdef _MSC_VER
#define ALWAYS_INLINE __forceinline
#define NOINLINE __declspec(noinline)
#define NORETURN __declspec(noreturn)
#define UNUSED
#else
# 47 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
#define ALWAYS_INLINE __attribute__((always_inline))
#define NOINLINE __attribute__((noinline))
#define NORETURN __attribute__((noreturn))
#define UNUSED __attribute__((unused))
#endif
# 52 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"

#if defined(__NetBSD__) && (defined(_KERNEL) || defined(_STANDALONE))
/*
 * Kernel and boot environment can't use normal headers,
 * so use the equivalent system headers.
 */
#if 0 /* expanded by -frewrite-includes */
#  include <machine/limits.h>
#endif /* expanded by -frewrite-includes */
# 58 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
# 59 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
#if 0 /* expanded by -frewrite-includes */
#  include <sys/stdint.h>
#endif /* expanded by -frewrite-includes */
# 59 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
# 60 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
#if 0 /* expanded by -frewrite-includes */
#  include <sys/types.h>
#endif /* expanded by -frewrite-includes */
# 60 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
# 61 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
#else
# 62 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
/* Include the standard compiler builtin headers we use functionality from. */
#if 0 /* expanded by -frewrite-includes */
#  include <limits.h>
#endif /* expanded by -frewrite-includes */
# 63 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
# 1 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/limits.h" 1 3 4
/*===---- limits.h - Standard header for integer sizes --------------------===*\
 *
 * Copyright (c) 2009 Chris Lattner
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
\*===----------------------------------------------------------------------===*/

#ifndef __CLANG_LIMITS_H
#define __CLANG_LIMITS_H

/* The system's limits.h may, in turn, try to #include_next GCC's limits.h.
   Avert this #include_next madness. */
#if defined __GNUC__ && !defined _GCC_LIMITS_H_
#define _GCC_LIMITS_H_
#endif
# 33 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/limits.h" 3 4

/* System headers include a number of constants from POSIX in <limits.h>.
   Include it if we're hosted. */
#if __STDC_HOSTED__ && (1)/*__has_include_next(<limits.h>)*/
#if 0 /* expanded by -frewrite-includes */
#include_next <limits.h>
#endif /* expanded by -frewrite-includes */
# 37 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/limits.h" 3 4
# 38 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/limits.h" 3 4
#endif
# 39 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/limits.h" 3 4

/* Many system headers try to "help us out" by defining these.  No really, we
   know how big each datatype is. */
#undef  SCHAR_MIN
#undef  SCHAR_MAX
#undef  UCHAR_MAX
#undef  SHRT_MIN
#undef  SHRT_MAX
#undef  USHRT_MAX
#undef  INT_MIN
#undef  INT_MAX
#undef  UINT_MAX
#undef  LONG_MIN
#undef  LONG_MAX
#undef  ULONG_MAX

#undef  CHAR_BIT
#undef  CHAR_MIN
#undef  CHAR_MAX

/* C90/99 5.2.4.2.1 */
#define SCHAR_MAX __SCHAR_MAX__
#define SHRT_MAX  __SHRT_MAX__
#define INT_MAX   __INT_MAX__
#define LONG_MAX  __LONG_MAX__

#define SCHAR_MIN (-__SCHAR_MAX__-1)
#define SHRT_MIN  (-__SHRT_MAX__ -1)
#define INT_MIN   (-__INT_MAX__  -1)
#define LONG_MIN  (-__LONG_MAX__ -1L)

#define UCHAR_MAX (__SCHAR_MAX__*2  +1)
#define USHRT_MAX (__SHRT_MAX__ *2  +1)
#define UINT_MAX  (__INT_MAX__  *2U +1U)
#define ULONG_MAX (__LONG_MAX__ *2UL+1UL)

#ifndef MB_LEN_MAX
#define MB_LEN_MAX 1
#endif
# 78 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/limits.h" 3 4

#define CHAR_BIT  __CHAR_BIT__

#ifdef __CHAR_UNSIGNED__  /* -funsigned-char */
#define CHAR_MIN 0
#define CHAR_MAX UCHAR_MAX
#else
# 85 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/limits.h" 3 4
#define CHAR_MIN SCHAR_MIN
#define CHAR_MAX __SCHAR_MAX__
#endif
# 88 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/limits.h" 3 4

/* C99 5.2.4.2.1: Added long long.
   C++11 18.3.3.2: same contents as the Standard C Library header <limits.h>.
 */
#if __STDC_VERSION__ >= 199901L || __cplusplus >= 201103L

#undef  LLONG_MIN
#undef  LLONG_MAX
#undef  ULLONG_MAX

#define LLONG_MAX  __LONG_LONG_MAX__
#define LLONG_MIN  (-__LONG_LONG_MAX__-1LL)
#define ULLONG_MAX (__LONG_LONG_MAX__*2ULL+1ULL)
#endif
# 102 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/limits.h" 3 4

/* LONG_LONG_MIN/LONG_LONG_MAX/ULONG_LONG_MAX are a GNU extension.  It's too bad
   that we don't have something like #pragma poison that could be used to
   deprecate a macro - the code should just use LLONG_MAX and friends.
 */
#if defined(__GNU_LIBRARY__) ? defined(__USE_GNU) : !defined(__STRICT_ANSI__)

#undef   LONG_LONG_MIN
#undef   LONG_LONG_MAX
#undef   ULONG_LONG_MAX

#define LONG_LONG_MAX  __LONG_LONG_MAX__
#define LONG_LONG_MIN  (-__LONG_LONG_MAX__-1LL)
#define ULONG_LONG_MAX (__LONG_LONG_MAX__*2ULL+1ULL)
#endif
# 117 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/limits.h" 3 4

#endif /* __CLANG_LIMITS_H */
# 119 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/limits.h" 3 4
# 64 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h" 2
#if 0 /* expanded by -frewrite-includes */
#  include <stdint.h>
#endif /* expanded by -frewrite-includes */
# 64 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
# 1 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 1 3 4
/*===---- stdint.h - Standard header for sized integer types --------------===*\
 *
 * Copyright (c) 2009 Chris Lattner
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
\*===----------------------------------------------------------------------===*/

#ifndef __CLANG_STDINT_H
#define __CLANG_STDINT_H

/* If we're hosted, fall back to the system's stdint.h, which might have
 * additional definitions.
 */
#if __STDC_HOSTED__ && (1)/*__has_include_next(<stdint.h>)*/

// C99 7.18.3 Limits of other integer types
//
//  Footnote 219, 220: C++ implementations should define these macros only when
//  __STDC_LIMIT_MACROS is defined before <stdint.h> is included.
//
//  Footnote 222: C++ implementations should define these macros only when
//  __STDC_CONSTANT_MACROS is defined before <stdint.h> is included.
//
// C++11 [cstdint.syn]p2:
//
//  The macros defined by <cstdint> are provided unconditionally. In particular,
//  the symbols __STDC_LIMIT_MACROS and __STDC_CONSTANT_MACROS (mentioned in
//  footnotes 219, 220, and 222 in the C standard) play no role in C++.
//
// C11 removed the problematic footnotes.
//
// Work around this inconsistency by always defining those macros in C++ mode,
// so that a C library implementation which follows the C99 standard can be
// used in C++.
# ifdef __cplusplus
#  if !defined(__STDC_LIMIT_MACROS)
#   define __STDC_LIMIT_MACROS
#   define __STDC_LIMIT_MACROS_DEFINED_BY_CLANG
#  endif
# 57 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#  if !defined(__STDC_CONSTANT_MACROS)
#   define __STDC_CONSTANT_MACROS
#   define __STDC_CONSTANT_MACROS_DEFINED_BY_CLANG
#  endif
# 61 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
# endif
# 62 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#if 0 /* expanded by -frewrite-includes */
# include_next <stdint.h>
#endif /* expanded by -frewrite-includes */
# 63 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
# 64 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

# ifdef __STDC_LIMIT_MACROS_DEFINED_BY_CLANG
#  undef __STDC_LIMIT_MACROS
#  undef __STDC_LIMIT_MACROS_DEFINED_BY_CLANG
# endif
# 69 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
# ifdef __STDC_CONSTANT_MACROS_DEFINED_BY_CLANG
#  undef __STDC_CONSTANT_MACROS
#  undef __STDC_CONSTANT_MACROS_DEFINED_BY_CLANG
# endif
# 73 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#else
# 75 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

/* C99 7.18.1.1 Exact-width integer types.
 * C99 7.18.1.2 Minimum-width integer types.
 * C99 7.18.1.3 Fastest minimum-width integer types.
 *
 * The standard requires that exact-width type be defined for 8-, 16-, 32-, and
 * 64-bit types if they are implemented. Other exact width types are optional.
 * This implementation defines an exact-width types for every integer width
 * that is represented in the standard integer types.
 *
 * The standard also requires minimum-width types be defined for 8-, 16-, 32-,
 * and 64-bit widths regardless of whether there are corresponding exact-width
 * types.
 *
 * To accommodate targets that are missing types that are exactly 8, 16, 32, or
 * 64 bits wide, this implementation takes an approach of cascading
 * redefintions, redefining __int_leastN_t to successively smaller exact-width
 * types. It is therefore important that the types are defined in order of
 * descending widths.
 *
 * We currently assume that the minimum-width types and the fastest
 * minimum-width types are the same. This is allowed by the standard, but is
 * suboptimal.
 *
 * In violation of the standard, some targets do not implement a type that is
 * wide enough to represent all of the required widths (8-, 16-, 32-, 64-bit).
 * To accommodate these targets, a required minimum-width type is only
 * defined if there exists an exact-width type of equal or greater width.
 */

#ifdef __INT64_TYPE__
# ifndef __int8_t_defined /* glibc sys/types.h also defines int64_t*/
typedef __INT64_TYPE__ int64_t;
# endif /* __int8_t_defined */
# 109 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
typedef __UINT64_TYPE__ uint64_t;
# define __int_least64_t int64_t
# define __uint_least64_t uint64_t
# define __int_least32_t int64_t
# define __uint_least32_t uint64_t
# define __int_least16_t int64_t
# define __uint_least16_t uint64_t
# define __int_least8_t int64_t
# define __uint_least8_t uint64_t
#endif /* __INT64_TYPE__ */
# 119 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#ifdef __int_least64_t
typedef __int_least64_t int_least64_t;
typedef __uint_least64_t uint_least64_t;
typedef __int_least64_t int_fast64_t;
typedef __uint_least64_t uint_fast64_t;
#endif /* __int_least64_t */
# 126 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#ifdef __INT56_TYPE__
typedef __INT56_TYPE__ int56_t;
typedef __UINT56_TYPE__ uint56_t;
typedef int56_t int_least56_t;
typedef uint56_t uint_least56_t;
typedef int56_t int_fast56_t;
typedef uint56_t uint_fast56_t;
# define __int_least32_t int56_t
# define __uint_least32_t uint56_t
# define __int_least16_t int56_t
# define __uint_least16_t uint56_t
# define __int_least8_t int56_t
# define __uint_least8_t uint56_t
#endif /* __INT56_TYPE__ */
# 141 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT48_TYPE__
typedef __INT48_TYPE__ int48_t;
typedef __UINT48_TYPE__ uint48_t;
typedef int48_t int_least48_t;
typedef uint48_t uint_least48_t;
typedef int48_t int_fast48_t;
typedef uint48_t uint_fast48_t;
# define __int_least32_t int48_t
# define __uint_least32_t uint48_t
# define __int_least16_t int48_t
# define __uint_least16_t uint48_t
# define __int_least8_t int48_t
# define __uint_least8_t uint48_t
#endif /* __INT48_TYPE__ */
# 157 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT40_TYPE__
typedef __INT40_TYPE__ int40_t;
typedef __UINT40_TYPE__ uint40_t;
typedef int40_t int_least40_t;
typedef uint40_t uint_least40_t;
typedef int40_t int_fast40_t;
typedef uint40_t uint_fast40_t;
# define __int_least32_t int40_t
# define __uint_least32_t uint40_t
# define __int_least16_t int40_t
# define __uint_least16_t uint40_t
# define __int_least8_t int40_t
# define __uint_least8_t uint40_t
#endif /* __INT40_TYPE__ */
# 173 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT32_TYPE__

# ifndef __int8_t_defined /* glibc sys/types.h also defines int32_t*/
typedef __INT32_TYPE__ int32_t;
# endif /* __int8_t_defined */
# 180 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

# ifndef __uint32_t_defined  /* more glibc compatibility */
# define __uint32_t_defined
typedef __UINT32_TYPE__ uint32_t;
# endif /* __uint32_t_defined */
# 185 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

# define __int_least32_t int32_t
# define __uint_least32_t uint32_t
# define __int_least16_t int32_t
# define __uint_least16_t uint32_t
# define __int_least8_t int32_t
# define __uint_least8_t uint32_t
#endif /* __INT32_TYPE__ */
# 193 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#ifdef __int_least32_t
typedef __int_least32_t int_least32_t;
typedef __uint_least32_t uint_least32_t;
typedef __int_least32_t int_fast32_t;
typedef __uint_least32_t uint_fast32_t;
#endif /* __int_least32_t */
# 200 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#ifdef __INT24_TYPE__
typedef __INT24_TYPE__ int24_t;
typedef __UINT24_TYPE__ uint24_t;
typedef int24_t int_least24_t;
typedef uint24_t uint_least24_t;
typedef int24_t int_fast24_t;
typedef uint24_t uint_fast24_t;
# define __int_least16_t int24_t
# define __uint_least16_t uint24_t
# define __int_least8_t int24_t
# define __uint_least8_t uint24_t
#endif /* __INT24_TYPE__ */
# 213 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#ifdef __INT16_TYPE__
#ifndef __int8_t_defined /* glibc sys/types.h also defines int16_t*/
typedef __INT16_TYPE__ int16_t;
#endif /* __int8_t_defined */
# 218 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
typedef __UINT16_TYPE__ uint16_t;
# define __int_least16_t int16_t
# define __uint_least16_t uint16_t
# define __int_least8_t int16_t
# define __uint_least8_t uint16_t
#endif /* __INT16_TYPE__ */
# 224 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#ifdef __int_least16_t
typedef __int_least16_t int_least16_t;
typedef __uint_least16_t uint_least16_t;
typedef __int_least16_t int_fast16_t;
typedef __uint_least16_t uint_fast16_t;
#endif /* __int_least16_t */
# 231 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT8_TYPE__
#ifndef __int8_t_defined  /* glibc sys/types.h also defines int8_t*/
typedef __INT8_TYPE__ int8_t;
#endif /* __int8_t_defined */
# 237 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
typedef __UINT8_TYPE__ uint8_t;
# define __int_least8_t int8_t
# define __uint_least8_t uint8_t
#endif /* __INT8_TYPE__ */
# 241 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#ifdef __int_least8_t
typedef __int_least8_t int_least8_t;
typedef __uint_least8_t uint_least8_t;
typedef __int_least8_t int_fast8_t;
typedef __uint_least8_t uint_fast8_t;
#endif /* __int_least8_t */
# 248 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

/* prevent glibc sys/types.h from defining conflicting types */
#ifndef __int8_t_defined
# define __int8_t_defined
#endif /* __int8_t_defined */
# 253 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

/* C99 7.18.1.4 Integer types capable of holding object pointers.
 */
#define __stdint_join3(a,b,c) a ## b ## c

#define  __intn_t(n) __stdint_join3( int, n, _t)
#define __uintn_t(n) __stdint_join3(uint, n, _t)

#ifndef _INTPTR_T
#ifndef __intptr_t_defined
typedef  __intn_t(__INTPTR_WIDTH__)  intptr_t;
#define __intptr_t_defined
#define _INTPTR_T
#endif
# 267 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#endif
# 268 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#ifndef _UINTPTR_T
typedef __uintn_t(__INTPTR_WIDTH__) uintptr_t;
#define _UINTPTR_T
#endif
# 273 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

/* C99 7.18.1.5 Greatest-width integer types.
 */
typedef __INTMAX_TYPE__  intmax_t;
typedef __UINTMAX_TYPE__ uintmax_t;

/* C99 7.18.4 Macros for minimum-width integer constants.
 *
 * The standard requires that integer constant macros be defined for all the
 * minimum-width types defined above. As 8-, 16-, 32-, and 64-bit minimum-width
 * types are required, the corresponding integer constant macros are defined
 * here. This implementation also defines minimum-width types for every other
 * integer width that the target implements, so corresponding macros are
 * defined below, too.
 *
 * These macros are defined using the same successive-shrinking approach as
 * the type definitions above. It is likewise important that macros are defined
 * in order of decending width.
 *
 * Note that C++ should not check __STDC_CONSTANT_MACROS here, contrary to the
 * claims of the C standard (see C++ 18.3.1p2, [cstdint.syn]).
 */

#define __int_c_join(a, b) a ## b
#define __int_c(v, suffix) __int_c_join(v, suffix)
#define __uint_c(v, suffix) __int_c_join(v##U, suffix)


#ifdef __INT64_TYPE__
# ifdef __INT64_C_SUFFIX__
#  define __int64_c_suffix __INT64_C_SUFFIX__
#  define __int32_c_suffix __INT64_C_SUFFIX__
#  define __int16_c_suffix __INT64_C_SUFFIX__
#  define  __int8_c_suffix __INT64_C_SUFFIX__
# else
# 308 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#  undef __int64_c_suffix
#  undef __int32_c_suffix
#  undef __int16_c_suffix
#  undef  __int8_c_suffix
# endif /* __INT64_C_SUFFIX__ */
# 313 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#endif /* __INT64_TYPE__ */
# 314 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#ifdef __int_least64_t
# ifdef __int64_c_suffix
#  define INT64_C(v) __int_c(v, __int64_c_suffix)
#  define UINT64_C(v) __uint_c(v, __int64_c_suffix)
# else
# 320 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#  define INT64_C(v) v
#  define UINT64_C(v) v ## U
# endif /* __int64_c_suffix */
# 323 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#endif /* __int_least64_t */
# 324 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT56_TYPE__
# ifdef __INT56_C_SUFFIX__
#  define INT56_C(v) __int_c(v, __INT56_C_SUFFIX__)
#  define UINT56_C(v) __uint_c(v, __INT56_C_SUFFIX__)
#  define __int32_c_suffix __INT56_C_SUFFIX__
#  define __int16_c_suffix __INT56_C_SUFFIX__
#  define __int8_c_suffix  __INT56_C_SUFFIX__
# else
# 334 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#  define INT56_C(v) v
#  define UINT56_C(v) v ## U
#  undef __int32_c_suffix
#  undef __int16_c_suffix
#  undef  __int8_c_suffix
# endif /* __INT56_C_SUFFIX__ */
# 340 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#endif /* __INT56_TYPE__ */
# 341 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT48_TYPE__
# ifdef __INT48_C_SUFFIX__
#  define INT48_C(v) __int_c(v, __INT48_C_SUFFIX__)
#  define UINT48_C(v) __uint_c(v, __INT48_C_SUFFIX__)
#  define __int32_c_suffix __INT48_C_SUFFIX__
#  define __int16_c_suffix __INT48_C_SUFFIX__
#  define __int8_c_suffix  __INT48_C_SUFFIX__
# else
# 351 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#  define INT48_C(v) v
#  define UINT48_C(v) v ## U
#  undef __int32_c_suffix
#  undef __int16_c_suffix
#  undef  __int8_c_suffix
# endif /* __INT48_C_SUFFIX__ */
# 357 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#endif /* __INT48_TYPE__ */
# 358 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT40_TYPE__
# ifdef __INT40_C_SUFFIX__
#  define INT40_C(v) __int_c(v, __INT40_C_SUFFIX__)
#  define UINT40_C(v) __uint_c(v, __INT40_C_SUFFIX__)
#  define __int32_c_suffix __INT40_C_SUFFIX__
#  define __int16_c_suffix __INT40_C_SUFFIX__
#  define __int8_c_suffix  __INT40_C_SUFFIX__
# else
# 368 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#  define INT40_C(v) v
#  define UINT40_C(v) v ## U
#  undef __int32_c_suffix
#  undef __int16_c_suffix
#  undef  __int8_c_suffix
# endif /* __INT40_C_SUFFIX__ */
# 374 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#endif /* __INT40_TYPE__ */
# 375 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT32_TYPE__
# ifdef __INT32_C_SUFFIX__
#  define __int32_c_suffix __INT32_C_SUFFIX__
#  define __int16_c_suffix __INT32_C_SUFFIX__
#  define __int8_c_suffix  __INT32_C_SUFFIX__
#else
# 383 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#  undef __int32_c_suffix
#  undef __int16_c_suffix
#  undef  __int8_c_suffix
# endif /* __INT32_C_SUFFIX__ */
# 387 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#endif /* __INT32_TYPE__ */
# 388 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#ifdef __int_least32_t
# ifdef __int32_c_suffix
#  define INT32_C(v) __int_c(v, __int32_c_suffix)
#  define UINT32_C(v) __uint_c(v, __int32_c_suffix)
# else
# 394 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#  define INT32_C(v) v
#  define UINT32_C(v) v ## U
# endif /* __int32_c_suffix */
# 397 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#endif /* __int_least32_t */
# 398 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT24_TYPE__
# ifdef __INT24_C_SUFFIX__
#  define INT24_C(v) __int_c(v, __INT24_C_SUFFIX__)
#  define UINT24_C(v) __uint_c(v, __INT24_C_SUFFIX__)
#  define __int16_c_suffix __INT24_C_SUFFIX__
#  define __int8_c_suffix  __INT24_C_SUFFIX__
# else
# 407 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#  define INT24_C(v) v
#  define UINT24_C(v) v ## U
#  undef __int16_c_suffix
#  undef  __int8_c_suffix
# endif /* __INT24_C_SUFFIX__ */
# 412 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#endif /* __INT24_TYPE__ */
# 413 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT16_TYPE__
# ifdef __INT16_C_SUFFIX__
#  define __int16_c_suffix __INT16_C_SUFFIX__
#  define __int8_c_suffix  __INT16_C_SUFFIX__
#else
# 420 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#  undef __int16_c_suffix
#  undef  __int8_c_suffix
# endif /* __INT16_C_SUFFIX__ */
# 423 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#endif /* __INT16_TYPE__ */
# 424 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#ifdef __int_least16_t
# ifdef __int16_c_suffix
#  define INT16_C(v) __int_c(v, __int16_c_suffix)
#  define UINT16_C(v) __uint_c(v, __int16_c_suffix)
# else
# 430 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#  define INT16_C(v) v
#  define UINT16_C(v) v ## U
# endif /* __int16_c_suffix */
# 433 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#endif /* __int_least16_t */
# 434 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT8_TYPE__
# ifdef __INT8_C_SUFFIX__
#  define __int8_c_suffix __INT8_C_SUFFIX__
#else
# 440 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#  undef  __int8_c_suffix
# endif /* __INT8_C_SUFFIX__ */
# 442 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#endif /* __INT8_TYPE__ */
# 443 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#ifdef __int_least8_t
# ifdef __int8_c_suffix
#  define INT8_C(v) __int_c(v, __int8_c_suffix)
#  define UINT8_C(v) __uint_c(v, __int8_c_suffix)
# else
# 449 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#  define INT8_C(v) v
#  define UINT8_C(v) v ## U
# endif /* __int8_c_suffix */
# 452 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#endif /* __int_least8_t */
# 453 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


/* C99 7.18.2.1 Limits of exact-width integer types.
 * C99 7.18.2.2 Limits of minimum-width integer types.
 * C99 7.18.2.3 Limits of fastest minimum-width integer types.
 *
 * The presence of limit macros are completely optional in C99.  This
 * implementation defines limits for all of the types (exact- and
 * minimum-width) that it defines above, using the limits of the minimum-width
 * type for any types that do not have exact-width representations.
 *
 * As in the type definitions, this section takes an approach of
 * successive-shrinking to determine which limits to use for the standard (8,
 * 16, 32, 64) bit widths when they don't have exact representations. It is
 * therefore important that the defintions be kept in order of decending
 * widths.
 *
 * Note that C++ should not check __STDC_LIMIT_MACROS here, contrary to the
 * claims of the C standard (see C++ 18.3.1p2, [cstdint.syn]).
 */

#ifdef __INT64_TYPE__
# define INT64_MAX           INT64_C( 9223372036854775807)
# define INT64_MIN         (-INT64_C( 9223372036854775807)-1)
# define UINT64_MAX         UINT64_C(18446744073709551615)
# define __INT_LEAST64_MIN   INT64_MIN
# define __INT_LEAST64_MAX   INT64_MAX
# define __UINT_LEAST64_MAX UINT64_MAX
# define __INT_LEAST32_MIN   INT64_MIN
# define __INT_LEAST32_MAX   INT64_MAX
# define __UINT_LEAST32_MAX UINT64_MAX
# define __INT_LEAST16_MIN   INT64_MIN
# define __INT_LEAST16_MAX   INT64_MAX
# define __UINT_LEAST16_MAX UINT64_MAX
# define __INT_LEAST8_MIN    INT64_MIN
# define __INT_LEAST8_MAX    INT64_MAX
# define __UINT_LEAST8_MAX  UINT64_MAX
#endif /* __INT64_TYPE__ */
# 491 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#ifdef __INT_LEAST64_MIN
# define INT_LEAST64_MIN   __INT_LEAST64_MIN
# define INT_LEAST64_MAX   __INT_LEAST64_MAX
# define UINT_LEAST64_MAX __UINT_LEAST64_MAX
# define INT_FAST64_MIN    __INT_LEAST64_MIN
# define INT_FAST64_MAX    __INT_LEAST64_MAX
# define UINT_FAST64_MAX  __UINT_LEAST64_MAX
#endif /* __INT_LEAST64_MIN */
# 500 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT56_TYPE__
# define INT56_MAX           INT56_C(36028797018963967)
# define INT56_MIN         (-INT56_C(36028797018963967)-1)
# define UINT56_MAX         UINT56_C(72057594037927935)
# define INT_LEAST56_MIN     INT56_MIN
# define INT_LEAST56_MAX     INT56_MAX
# define UINT_LEAST56_MAX   UINT56_MAX
# define INT_FAST56_MIN      INT56_MIN
# define INT_FAST56_MAX      INT56_MAX
# define UINT_FAST56_MAX    UINT56_MAX
# define __INT_LEAST32_MIN   INT56_MIN
# define __INT_LEAST32_MAX   INT56_MAX
# define __UINT_LEAST32_MAX UINT56_MAX
# define __INT_LEAST16_MIN   INT56_MIN
# define __INT_LEAST16_MAX   INT56_MAX
# define __UINT_LEAST16_MAX UINT56_MAX
# define __INT_LEAST8_MIN    INT56_MIN
# define __INT_LEAST8_MAX    INT56_MAX
# define __UINT_LEAST8_MAX  UINT56_MAX
#endif /* __INT56_TYPE__ */
# 522 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT48_TYPE__
# define INT48_MAX           INT48_C(140737488355327)
# define INT48_MIN         (-INT48_C(140737488355327)-1)
# define UINT48_MAX         UINT48_C(281474976710655)
# define INT_LEAST48_MIN     INT48_MIN
# define INT_LEAST48_MAX     INT48_MAX
# define UINT_LEAST48_MAX   UINT48_MAX
# define INT_FAST48_MIN      INT48_MIN
# define INT_FAST48_MAX      INT48_MAX
# define UINT_FAST48_MAX    UINT48_MAX
# define __INT_LEAST32_MIN   INT48_MIN
# define __INT_LEAST32_MAX   INT48_MAX
# define __UINT_LEAST32_MAX UINT48_MAX
# define __INT_LEAST16_MIN   INT48_MIN
# define __INT_LEAST16_MAX   INT48_MAX
# define __UINT_LEAST16_MAX UINT48_MAX
# define __INT_LEAST8_MIN    INT48_MIN
# define __INT_LEAST8_MAX    INT48_MAX
# define __UINT_LEAST8_MAX  UINT48_MAX
#endif /* __INT48_TYPE__ */
# 544 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT40_TYPE__
# define INT40_MAX           INT40_C(549755813887)
# define INT40_MIN         (-INT40_C(549755813887)-1)
# define UINT40_MAX         UINT40_C(1099511627775)
# define INT_LEAST40_MIN     INT40_MIN
# define INT_LEAST40_MAX     INT40_MAX
# define UINT_LEAST40_MAX   UINT40_MAX
# define INT_FAST40_MIN      INT40_MIN
# define INT_FAST40_MAX      INT40_MAX
# define UINT_FAST40_MAX    UINT40_MAX
# define __INT_LEAST32_MIN   INT40_MIN
# define __INT_LEAST32_MAX   INT40_MAX
# define __UINT_LEAST32_MAX UINT40_MAX
# define __INT_LEAST16_MIN   INT40_MIN
# define __INT_LEAST16_MAX   INT40_MAX
# define __UINT_LEAST16_MAX UINT40_MAX
# define __INT_LEAST8_MIN    INT40_MIN
# define __INT_LEAST8_MAX    INT40_MAX
# define __UINT_LEAST8_MAX  UINT40_MAX
#endif /* __INT40_TYPE__ */
# 566 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT32_TYPE__
# define INT32_MAX           INT32_C(2147483647)
# define INT32_MIN         (-INT32_C(2147483647)-1)
# define UINT32_MAX         UINT32_C(4294967295)
# define __INT_LEAST32_MIN   INT32_MIN
# define __INT_LEAST32_MAX   INT32_MAX
# define __UINT_LEAST32_MAX UINT32_MAX
# define __INT_LEAST16_MIN   INT32_MIN
# define __INT_LEAST16_MAX   INT32_MAX
# define __UINT_LEAST16_MAX UINT32_MAX
# define __INT_LEAST8_MIN    INT32_MIN
# define __INT_LEAST8_MAX    INT32_MAX
# define __UINT_LEAST8_MAX  UINT32_MAX
#endif /* __INT32_TYPE__ */
# 582 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#ifdef __INT_LEAST32_MIN
# define INT_LEAST32_MIN   __INT_LEAST32_MIN
# define INT_LEAST32_MAX   __INT_LEAST32_MAX
# define UINT_LEAST32_MAX __UINT_LEAST32_MAX
# define INT_FAST32_MIN    __INT_LEAST32_MIN
# define INT_FAST32_MAX    __INT_LEAST32_MAX
# define UINT_FAST32_MAX  __UINT_LEAST32_MAX
#endif /* __INT_LEAST32_MIN */
# 591 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT24_TYPE__
# define INT24_MAX           INT24_C(8388607)
# define INT24_MIN         (-INT24_C(8388607)-1)
# define UINT24_MAX         UINT24_C(16777215)
# define INT_LEAST24_MIN     INT24_MIN
# define INT_LEAST24_MAX     INT24_MAX
# define UINT_LEAST24_MAX   UINT24_MAX
# define INT_FAST24_MIN      INT24_MIN
# define INT_FAST24_MAX      INT24_MAX
# define UINT_FAST24_MAX    UINT24_MAX
# define __INT_LEAST16_MIN   INT24_MIN
# define __INT_LEAST16_MAX   INT24_MAX
# define __UINT_LEAST16_MAX UINT24_MAX
# define __INT_LEAST8_MIN    INT24_MIN
# define __INT_LEAST8_MAX    INT24_MAX
# define __UINT_LEAST8_MAX  UINT24_MAX
#endif /* __INT24_TYPE__ */
# 610 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT16_TYPE__
#define INT16_MAX            INT16_C(32767)
#define INT16_MIN          (-INT16_C(32767)-1)
#define UINT16_MAX          UINT16_C(65535)
# define __INT_LEAST16_MIN   INT16_MIN
# define __INT_LEAST16_MAX   INT16_MAX
# define __UINT_LEAST16_MAX UINT16_MAX
# define __INT_LEAST8_MIN    INT16_MIN
# define __INT_LEAST8_MAX    INT16_MAX
# define __UINT_LEAST8_MAX  UINT16_MAX
#endif /* __INT16_TYPE__ */
# 623 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#ifdef __INT_LEAST16_MIN
# define INT_LEAST16_MIN   __INT_LEAST16_MIN
# define INT_LEAST16_MAX   __INT_LEAST16_MAX
# define UINT_LEAST16_MAX __UINT_LEAST16_MAX
# define INT_FAST16_MIN    __INT_LEAST16_MIN
# define INT_FAST16_MAX    __INT_LEAST16_MAX
# define UINT_FAST16_MAX  __UINT_LEAST16_MAX
#endif /* __INT_LEAST16_MIN */
# 632 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4


#ifdef __INT8_TYPE__
# define INT8_MAX            INT8_C(127)
# define INT8_MIN          (-INT8_C(127)-1)
# define UINT8_MAX          UINT8_C(255)
# define __INT_LEAST8_MIN    INT8_MIN
# define __INT_LEAST8_MAX    INT8_MAX
# define __UINT_LEAST8_MAX  UINT8_MAX
#endif /* __INT8_TYPE__ */
# 642 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#ifdef __INT_LEAST8_MIN
# define INT_LEAST8_MIN   __INT_LEAST8_MIN
# define INT_LEAST8_MAX   __INT_LEAST8_MAX
# define UINT_LEAST8_MAX __UINT_LEAST8_MAX
# define INT_FAST8_MIN    __INT_LEAST8_MIN
# define INT_FAST8_MAX    __INT_LEAST8_MAX
# define UINT_FAST8_MAX  __UINT_LEAST8_MAX
#endif /* __INT_LEAST8_MIN */
# 651 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

/* Some utility macros */
#define  __INTN_MIN(n)  __stdint_join3( INT, n, _MIN)
#define  __INTN_MAX(n)  __stdint_join3( INT, n, _MAX)
#define __UINTN_MAX(n)  __stdint_join3(UINT, n, _MAX)
#define  __INTN_C(n, v) __stdint_join3( INT, n, _C(v))
#define __UINTN_C(n, v) __stdint_join3(UINT, n, _C(v))

/* C99 7.18.2.4 Limits of integer types capable of holding object pointers. */
/* C99 7.18.3 Limits of other integer types. */

#define  INTPTR_MIN  __INTN_MIN(__INTPTR_WIDTH__)
#define  INTPTR_MAX  __INTN_MAX(__INTPTR_WIDTH__)
#define UINTPTR_MAX __UINTN_MAX(__INTPTR_WIDTH__)
#define PTRDIFF_MIN  __INTN_MIN(__PTRDIFF_WIDTH__)
#define PTRDIFF_MAX  __INTN_MAX(__PTRDIFF_WIDTH__)
#define    SIZE_MAX __UINTN_MAX(__SIZE_WIDTH__)

/* ISO9899:2011 7.20 (C11 Annex K): Define RSIZE_MAX if __STDC_WANT_LIB_EXT1__
 * is enabled. */
#if defined(__STDC_WANT_LIB_EXT1__) && __STDC_WANT_LIB_EXT1__ >= 1
#define   RSIZE_MAX            (SIZE_MAX >> 1)
#endif
# 674 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

/* C99 7.18.2.5 Limits of greatest-width integer types. */
#define INTMAX_MIN   __INTN_MIN(__INTMAX_WIDTH__)
#define INTMAX_MAX   __INTN_MAX(__INTMAX_WIDTH__)
#define UINTMAX_MAX __UINTN_MAX(__INTMAX_WIDTH__)

/* C99 7.18.3 Limits of other integer types. */
#define SIG_ATOMIC_MIN __INTN_MIN(__SIG_ATOMIC_WIDTH__)
#define SIG_ATOMIC_MAX __INTN_MAX(__SIG_ATOMIC_WIDTH__)
#ifdef __WINT_UNSIGNED__
# define WINT_MIN       __UINTN_C(__WINT_WIDTH__, 0)
# define WINT_MAX       __UINTN_MAX(__WINT_WIDTH__)
#else
# 687 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
# define WINT_MIN       __INTN_MIN(__WINT_WIDTH__)
# define WINT_MAX       __INTN_MAX(__WINT_WIDTH__)
#endif
# 690 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

#ifndef WCHAR_MAX
# define WCHAR_MAX __WCHAR_MAX__
#endif
# 694 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#ifndef WCHAR_MIN
# if __WCHAR_MAX__ == __INTN_MAX(__WCHAR_WIDTH__)
#  define WCHAR_MIN __INTN_MIN(__WCHAR_WIDTH__)
# else
# 698 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#  define WCHAR_MIN __UINTN_C(__WCHAR_WIDTH__, 0)
# endif
# 700 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#endif
# 701 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4

/* 7.18.4.2 Macros for greatest-width integer constants. */
#define INTMAX_C(v)   __INTN_C(__INTMAX_WIDTH__, v)
#define UINTMAX_C(v) __UINTN_C(__INTMAX_WIDTH__, v)

#endif /* __STDC_HOSTED__ */
# 707 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
#endif /* __CLANG_STDINT_H */
# 708 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdint.h" 3 4
# 65 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h" 2
#if 0 /* expanded by -frewrite-includes */
#  include <stdbool.h>
#endif /* expanded by -frewrite-includes */
# 65 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
# 1 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdbool.h" 1 3 4
/*===---- stdbool.h - Standard header for booleans -------------------------===
 *
 * Copyright (c) 2008 Eli Friedman
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 *===-----------------------------------------------------------------------===
 */

#ifndef __STDBOOL_H
#define __STDBOOL_H

/* Don't define bool, true, and false in C++, except as a GNU extension. */
#ifndef __cplusplus
#define bool _Bool
#define true 1
#define false 0
#elif defined(__GNUC__) && !defined(__STRICT_ANSI__)
# 35 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdbool.h" 3 4
/* Define _Bool, bool, false, true as a GNU extension. */
#define _Bool bool
#define bool  bool
#define false false
#define true  true
#endif
# 41 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdbool.h" 3 4

#define __bool_true_false_are_defined 1

#endif /* __STDBOOL_H */
# 45 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/stdbool.h" 3 4
# 66 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h" 2
#if 0 /* expanded by -frewrite-includes */
#  include <float.h>
#endif /* expanded by -frewrite-includes */
# 66 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
# 1 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/float.h" 1 3 4
/*===---- float.h - Characteristics of floating point types ----------------===
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 *===-----------------------------------------------------------------------===
 */

#ifndef __FLOAT_H
#define __FLOAT_H

/* If we're on MinGW, fall back to the system's float.h, which might have
 * additional definitions provided for Windows.
 * For more details see http://msdn.microsoft.com/en-us/library/y0ybw9fy.aspx
 */
#if (defined(__MINGW32__) || defined(_MSC_VER)) && __STDC_HOSTED__ && \
    (1)/*__has_include_next(<float.h>)*/
#if 0 /* expanded by -frewrite-includes */
#  include_next <float.h>
#endif /* expanded by -frewrite-includes */
# 33 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/float.h" 3 4
# 34 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/float.h" 3 4

/* Undefine anything that we'll be redefining below. */
#  undef FLT_EVAL_METHOD
#  undef FLT_ROUNDS
#  undef FLT_RADIX
#  undef FLT_MANT_DIG
#  undef DBL_MANT_DIG
#  undef LDBL_MANT_DIG
#  if __STDC_VERSION__ >= 199901L || !defined(__STRICT_ANSI__)
#    undef DECIMAL_DIG
#  endif
# 45 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/float.h" 3 4
#  undef FLT_DIG
#  undef DBL_DIG
#  undef LDBL_DIG
#  undef FLT_MIN_EXP
#  undef DBL_MIN_EXP
#  undef LDBL_MIN_EXP
#  undef FLT_MIN_10_EXP
#  undef DBL_MIN_10_EXP
#  undef LDBL_MIN_10_EXP
#  undef FLT_MAX_EXP
#  undef DBL_MAX_EXP
#  undef LDBL_MAX_EXP
#  undef FLT_MAX_10_EXP
#  undef DBL_MAX_10_EXP
#  undef LDBL_MAX_10_EXP
#  undef FLT_MAX
#  undef DBL_MAX
#  undef LDBL_MAX
#  undef FLT_EPSILON
#  undef DBL_EPSILON
#  undef LDBL_EPSILON
#  undef FLT_MIN
#  undef DBL_MIN
#  undef LDBL_MIN
#  if __STDC_VERSION__ >= 201112L || !defined(__STRICT_ANSI__)
#    undef FLT_TRUE_MIN
#    undef DBL_TRUE_MIN
#    undef LDBL_TRUE_MIN
#    undef FLT_DECIMAL_DIG
#    undef DBL_DECIMAL_DIG
#    undef LDBL_DECIMAL_DIG
#  endif
# 77 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/float.h" 3 4
#endif
# 78 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/float.h" 3 4

/* Characteristics of floating point types, C99 5.2.4.2.2 */

#define FLT_EVAL_METHOD __FLT_EVAL_METHOD__
#define FLT_ROUNDS (__builtin_flt_rounds())
#define FLT_RADIX __FLT_RADIX__

#define FLT_MANT_DIG __FLT_MANT_DIG__
#define DBL_MANT_DIG __DBL_MANT_DIG__
#define LDBL_MANT_DIG __LDBL_MANT_DIG__

#if __STDC_VERSION__ >= 199901L || !defined(__STRICT_ANSI__)
#  define DECIMAL_DIG __DECIMAL_DIG__
#endif
# 92 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/float.h" 3 4

#define FLT_DIG __FLT_DIG__
#define DBL_DIG __DBL_DIG__
#define LDBL_DIG __LDBL_DIG__

#define FLT_MIN_EXP __FLT_MIN_EXP__
#define DBL_MIN_EXP __DBL_MIN_EXP__
#define LDBL_MIN_EXP __LDBL_MIN_EXP__

#define FLT_MIN_10_EXP __FLT_MIN_10_EXP__
#define DBL_MIN_10_EXP __DBL_MIN_10_EXP__
#define LDBL_MIN_10_EXP __LDBL_MIN_10_EXP__

#define FLT_MAX_EXP __FLT_MAX_EXP__
#define DBL_MAX_EXP __DBL_MAX_EXP__
#define LDBL_MAX_EXP __LDBL_MAX_EXP__

#define FLT_MAX_10_EXP __FLT_MAX_10_EXP__
#define DBL_MAX_10_EXP __DBL_MAX_10_EXP__
#define LDBL_MAX_10_EXP __LDBL_MAX_10_EXP__

#define FLT_MAX __FLT_MAX__
#define DBL_MAX __DBL_MAX__
#define LDBL_MAX __LDBL_MAX__

#define FLT_EPSILON __FLT_EPSILON__
#define DBL_EPSILON __DBL_EPSILON__
#define LDBL_EPSILON __LDBL_EPSILON__

#define FLT_MIN __FLT_MIN__
#define DBL_MIN __DBL_MIN__
#define LDBL_MIN __LDBL_MIN__

#if __STDC_VERSION__ >= 201112L || !defined(__STRICT_ANSI__)
#  define FLT_TRUE_MIN __FLT_DENORM_MIN__
#  define DBL_TRUE_MIN __DBL_DENORM_MIN__
#  define LDBL_TRUE_MIN __LDBL_DENORM_MIN__
#  define FLT_DECIMAL_DIG __FLT_DECIMAL_DIG__
#  define DBL_DECIMAL_DIG __DBL_DECIMAL_DIG__
#  define LDBL_DECIMAL_DIG __LDBL_DECIMAL_DIG__
#endif
# 133 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/float.h" 3 4

#endif /* __FLOAT_H */
# 135 "/Users/buildslave/jenkins/sharedspace/phase1@2/clang-build/Build/bin/../lib/clang/4.0.99/include/float.h" 3 4
# 67 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h" 2
#endif
# 68 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"

/* Include the commonly used internal type definitions. */
#if 0 /* expanded by -frewrite-includes */
#include "int_types.h"
#endif /* expanded by -frewrite-includes */
# 70 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
# 1 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h" 1
/* ===-- int_lib.h - configuration header for compiler-rt  -----------------===
 *
 *                     The LLVM Compiler Infrastructure
 *
 * This file is dual licensed under the MIT and the University of Illinois Open
 * Source Licenses. See LICENSE.TXT for details.
 *
 * ===----------------------------------------------------------------------===
 *
 * This file is not part of the interface of this library.
 *
 * This file defines various standard types, most importantly a number of unions
 * used to access parts of larger types.
 *
 * ===----------------------------------------------------------------------===
 */

#ifndef INT_TYPES_H
#define INT_TYPES_H

#if 0 /* expanded by -frewrite-includes */
#include "int_endianness.h"
#endif /* expanded by -frewrite-includes */
# 21 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h"
# 1 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h" 1
/* ===-- int_endianness.h - configuration header for compiler-rt ------------===
 *
 *		       The LLVM Compiler Infrastructure
 *
 * This file is dual licensed under the MIT and the University of Illinois Open
 * Source Licenses. See LICENSE.TXT for details.
 *
 * ===----------------------------------------------------------------------===
 *
 * This file is a configuration header for compiler-rt.
 * This file is not part of the interface of this library.
 *
 * ===----------------------------------------------------------------------===
 */

#ifndef INT_ENDIANNESS_H
#define INT_ENDIANNESS_H

#if defined(__BYTE_ORDER__) && defined(__ORDER_BIG_ENDIAN__) && \
    defined(__ORDER_LITTLE_ENDIAN__)

/* Clang and GCC provide built-in endianness definitions. */
#if __BYTE_ORDER__ == __ORDER_BIG_ENDIAN__
#define _YUGA_LITTLE_ENDIAN 0
#define _YUGA_BIG_ENDIAN    1
#elif __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
# 27 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"
#define _YUGA_LITTLE_ENDIAN 1
#define _YUGA_BIG_ENDIAN    0
#endif /* __BYTE_ORDER__ */
# 30 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"

#else /* Compilers other than Clang or GCC. */
# 32 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"

#if defined(__SVR4) && defined(__sun)
#if 0 /* expanded by -frewrite-includes */
#include <sys/byteorder.h>
#endif /* expanded by -frewrite-includes */
# 34 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"
# 35 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"

#if defined(_BIG_ENDIAN)
#define _YUGA_LITTLE_ENDIAN 0
#define _YUGA_BIG_ENDIAN    1
#elif defined(_LITTLE_ENDIAN)
# 40 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"
#define _YUGA_LITTLE_ENDIAN 1
#define _YUGA_BIG_ENDIAN    0
#else /* !_LITTLE_ENDIAN */
# 43 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"
#error "unknown endianness"
#endif /* !_LITTLE_ENDIAN */
# 45 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"

#endif /* Solaris and AuroraUX. */
# 47 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"

/* .. */

#if defined(__FreeBSD__) || defined(__NetBSD__) || defined(__DragonFly__) ||   \
    defined(__minix)
#if 0 /* expanded by -frewrite-includes */
#include <sys/endian.h>
#endif /* expanded by -frewrite-includes */
# 52 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"
# 53 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"

#if _BYTE_ORDER == _BIG_ENDIAN
#define _YUGA_LITTLE_ENDIAN 0
#define _YUGA_BIG_ENDIAN    1
#elif _BYTE_ORDER == _LITTLE_ENDIAN
# 58 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"
#define _YUGA_LITTLE_ENDIAN 1
#define _YUGA_BIG_ENDIAN    0
#endif /* _BYTE_ORDER */
# 61 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"

#endif /* *BSD */
# 63 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"

#if defined(__OpenBSD__) || defined(__Bitrig__)
#if 0 /* expanded by -frewrite-includes */
#include <machine/endian.h>
#endif /* expanded by -frewrite-includes */
# 65 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"
# 66 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"

#if _BYTE_ORDER == _BIG_ENDIAN
#define _YUGA_LITTLE_ENDIAN 0
#define _YUGA_BIG_ENDIAN    1
#elif _BYTE_ORDER == _LITTLE_ENDIAN
# 71 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"
#define _YUGA_LITTLE_ENDIAN 1
#define _YUGA_BIG_ENDIAN    0
#endif /* _BYTE_ORDER */
# 74 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"

#endif /* OpenBSD and Bitrig. */
# 76 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"

/* .. */

/* Mac OSX has __BIG_ENDIAN__ or __LITTLE_ENDIAN__ automatically set by the
 * compiler (at least with GCC) */
#if defined(__APPLE__) || defined(__ellcc__ )

#ifdef __BIG_ENDIAN__
#if __BIG_ENDIAN__
#define _YUGA_LITTLE_ENDIAN 0
#define _YUGA_BIG_ENDIAN    1
#endif
# 88 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"
#endif /* __BIG_ENDIAN__ */
# 89 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"

#ifdef __LITTLE_ENDIAN__
#if __LITTLE_ENDIAN__
#define _YUGA_LITTLE_ENDIAN 1
#define _YUGA_BIG_ENDIAN    0
#endif
# 95 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"
#endif /* __LITTLE_ENDIAN__ */
# 96 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"

#endif /* Mac OSX */
# 98 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"

/* .. */

#if defined(_WIN32)

#define _YUGA_LITTLE_ENDIAN 1
#define _YUGA_BIG_ENDIAN    0

#endif /* Windows */
# 107 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"

#endif /* Clang or GCC. */
# 109 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"

/* . */

#if !defined(_YUGA_LITTLE_ENDIAN) || !defined(_YUGA_BIG_ENDIAN)
#error Unable to determine endian
#endif /* Check we found an endianness correctly. */
# 115 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"

#endif /* INT_ENDIANNESS_H */
# 117 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_endianness.h"
# 22 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h" 2

/* si_int is defined in Linux sysroot's asm-generic/siginfo.h */
#ifdef si_int
#undef si_int
#endif
# 27 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h"
typedef      int si_int;
typedef unsigned su_int;

typedef          long long di_int;
typedef unsigned long long du_int;

typedef union
{
    di_int all;
    struct
    {
#if _YUGA_LITTLE_ENDIAN
        su_int low;
        si_int high;
#else
# 42 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h"
        si_int high;
        su_int low;
#endif /* _YUGA_LITTLE_ENDIAN */
# 45 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h"
    }s;
} dwords;

typedef union
{
    du_int all;
    struct
    {
#if _YUGA_LITTLE_ENDIAN
        su_int low;
        su_int high;
#else
# 57 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h"
        su_int high;
        su_int low;
#endif /* _YUGA_LITTLE_ENDIAN */
# 60 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h"
    }s;
} udwords;

/* MIPS64 issue: PR 20098 */
#if (defined(__LP64__) || defined(__wasm__)) && \
    !(defined(__mips__) && defined(__clang__))
#define CRT_HAS_128BIT
#endif
# 68 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h"

#ifdef CRT_HAS_128BIT
typedef int      ti_int __attribute__ ((mode (TI)));
typedef unsigned tu_int __attribute__ ((mode (TI)));

typedef union
{
    ti_int all;
    struct
    {
#if _YUGA_LITTLE_ENDIAN
        du_int low;
        di_int high;
#else
# 82 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h"
        di_int high;
        du_int low;
#endif /* _YUGA_LITTLE_ENDIAN */
# 85 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h"
    }s;
} twords;

typedef union
{
    tu_int all;
    struct
    {
#if _YUGA_LITTLE_ENDIAN
        du_int low;
        du_int high;
#else
# 97 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h"
        du_int high;
        du_int low;
#endif /* _YUGA_LITTLE_ENDIAN */
# 100 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h"
    }s;
} utwords;

static __inline ti_int make_ti(di_int h, di_int l) {
    twords r;
    r.s.high = h;
    r.s.low = l;
    return r.all;
}

static __inline tu_int make_tu(du_int h, du_int l) {
    utwords r;
    r.s.high = h;
    r.s.low = l;
    return r.all;
}

#endif /* CRT_HAS_128BIT */
# 118 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h"

typedef union
{
    su_int u;
    float f;
} float_bits;

typedef union
{
    udwords u;
    double  f;
} double_bits;

typedef struct
{
#if _YUGA_LITTLE_ENDIAN
    udwords low;
    udwords high;
#else
# 137 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h"
    udwords high;
    udwords low;
#endif /* _YUGA_LITTLE_ENDIAN */
# 140 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h"
} uqwords;

typedef union
{
    uqwords     u;
    long double f;
} long_double_bits;

#if __STDC_VERSION__ >= 199901L
typedef float _Complex Fcomplex;
typedef double _Complex Dcomplex;
typedef long double _Complex Lcomplex;

#define COMPLEX_REAL(x) __real__(x)
#define COMPLEX_IMAGINARY(x) __imag__(x)
#else
# 156 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h"
typedef struct { float real, imaginary; } Fcomplex;

typedef struct { double real, imaginary; } Dcomplex;

typedef struct { long double real, imaginary; } Lcomplex;

#define COMPLEX_REAL(x) (x).real
#define COMPLEX_IMAGINARY(x) (x).imaginary
#endif
# 165 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h"
#endif /* INT_TYPES_H */
# 166 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_types.h"

# 71 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h" 2

/* Include internal utility function declarations. */
#if 0 /* expanded by -frewrite-includes */
#include "int_util.h"
#endif /* expanded by -frewrite-includes */
# 73 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
# 1 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_util.h" 1
/* ===-- int_util.h - internal utility functions ----------------------------===
 *
 *                     The LLVM Compiler Infrastructure
 *
 * This file is dual licensed under the MIT and the University of Illinois Open
 * Source Licenses. See LICENSE.TXT for details.
 *
 * ===-----------------------------------------------------------------------===
 *
 * This file is not part of the interface of this library.
 *
 * This file defines non-inline utilities which are available for use in the
 * library. The function definitions themselves are all contained in int_util.c
 * which will always be compiled into any compiler-rt library.
 *
 * ===-----------------------------------------------------------------------===
 */

#ifndef INT_UTIL_H
#define INT_UTIL_H

/** \brief Trigger a program abort (or panic for kernel code). */
#define compilerrt_abort() compilerrt_abort_impl(__FILE__, __LINE__, __func__)

NORETURN void compilerrt_abort_impl(const char *file, int line,
                                    const char *function);

#define COMPILE_TIME_ASSERT(expr) COMPILE_TIME_ASSERT1(expr, __COUNTER__)
#define COMPILE_TIME_ASSERT1(expr, cnt) COMPILE_TIME_ASSERT2(expr, cnt)
#define COMPILE_TIME_ASSERT2(expr, cnt)                                        \
  typedef char ct_assert_##cnt[(expr) ? 1 : -1] UNUSED

#endif /* INT_UTIL_H */
# 34 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_util.h"
# 74 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h" 2

COMPILER_RT_ABI si_int __paritysi2(si_int a);
COMPILER_RT_ABI si_int __paritydi2(di_int a);

COMPILER_RT_ABI di_int __divdi3(di_int a, di_int b);
COMPILER_RT_ABI si_int __divsi3(si_int a, si_int b);
COMPILER_RT_ABI su_int __udivsi3(su_int n, su_int d);

COMPILER_RT_ABI su_int __udivmodsi4(su_int a, su_int b, su_int* rem);
COMPILER_RT_ABI du_int __udivmoddi4(du_int a, du_int b, du_int* rem);
#ifdef CRT_HAS_128BIT
COMPILER_RT_ABI si_int __clzti2(ti_int a);
COMPILER_RT_ABI tu_int __udivmodti4(tu_int a, tu_int b, tu_int* rem);
#endif
# 88 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"

/* Definitions for builtins unavailable on MSVC */
#if defined(_MSC_VER) && !defined(__clang__)
#if 0 /* expanded by -frewrite-includes */
#include <intrin.h>
#endif /* expanded by -frewrite-includes */
# 91 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
# 92 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"

uint32_t __inline __builtin_ctz(uint32_t value) {
  unsigned long trailing_zero = 0;
  if (_BitScanForward(&trailing_zero, value))
    return trailing_zero;
  return 32;
}

uint32_t __inline __builtin_clz(uint32_t value) {
  unsigned long leading_zero = 0;
  if (_BitScanReverse(&leading_zero, value))
    return 31 - leading_zero;
  return 32;
}

#if defined(_M_ARM) || defined(_M_X64)
uint32_t __inline __builtin_clzll(uint64_t value) {
  unsigned long leading_zero = 0;
  if (_BitScanReverse64(&leading_zero, value))
    return 63 - leading_zero;
  return 64;
}
#else
# 115 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
uint32_t __inline __builtin_clzll(uint64_t value) {
  if (value == 0)
    return 64;
  uint32_t msh = (uint32_t)(value >> 32);
  uint32_t lsh = (uint32_t)(value & 0xFFFFFFFF);
  if (msh != 0)
    return __builtin_clz(msh);
  return 32 + __builtin_clz(lsh);
}
#endif
# 125 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"

#define __builtin_clzl __builtin_clzll
#endif /* defined(_MSC_VER) && !defined(__clang__) */
# 128 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"

#endif /* INT_LIB_H */
# 130 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_lib.h"
# 16 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/mulsc3.c" 2
#if 0 /* expanded by -frewrite-includes */
#include "int_math.h"
#endif /* expanded by -frewrite-includes */
# 16 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/mulsc3.c"
# 1 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h" 1
/* ===-- int_math.h - internal math inlines ---------------------------------===
 *
 *                     The LLVM Compiler Infrastructure
 *
 * This file is dual licensed under the MIT and the University of Illinois Open
 * Source Licenses. See LICENSE.TXT for details.
 *
 * ===-----------------------------------------------------------------------===
 *
 * This file is not part of the interface of this library.
 *
 * This file defines substitutes for the libm functions used in some of the
 * compiler-rt implementations, defined in such a way that there is not a direct
 * dependency on libm or math.h. Instead, we use the compiler builtin versions
 * where available. This reduces our dependencies on the system SDK by foisting
 * the responsibility onto the compiler.
 *
 * ===-----------------------------------------------------------------------===
 */

#ifndef INT_MATH_H
#define INT_MATH_H

#ifndef __has_builtin
#  define  __has_builtin(x) 0
#endif
# 27 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"

#if defined(_MSC_VER) && !defined(__clang__)
#if 0 /* expanded by -frewrite-includes */
#include <math.h>
#endif /* expanded by -frewrite-includes */
# 29 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"
# 30 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"
#if 0 /* expanded by -frewrite-includes */
#include <stdlib.h>
#endif /* expanded by -frewrite-includes */
# 30 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"
# 31 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"
#if 0 /* expanded by -frewrite-includes */
#include <ymath.h>
#endif /* expanded by -frewrite-includes */
# 31 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"
# 32 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"
#endif
# 33 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"

#if defined(_MSC_VER) && !defined(__clang__)
#define CRT_INFINITY INFINITY
#else
# 37 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"
#define CRT_INFINITY __builtin_huge_valf()
#endif
# 39 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"

#if defined(_MSC_VER) && !defined(__clang__)
#define crt_isfinite(x) _finite((x))
#define crt_isinf(x) !_finite((x))
#define crt_isnan(x) _isnan((x))
#else
# 45 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"
/* Define crt_isfinite in terms of the builtin if available, otherwise provide
 * an alternate version in terms of our other functions. This supports some
 * versions of GCC which didn't have __builtin_isfinite.
 */
#if __has_builtin(__builtin_isfinite)
#  define crt_isfinite(x) __builtin_isfinite((x))
#elif defined(__GNUC__)
# 52 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"
#  define crt_isfinite(x) \
  __extension__(({ \
      __typeof((x)) x_ = (x); \
      !crt_isinf(x_) && !crt_isnan(x_); \
    }))
#else
# 58 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"
#  error "Do not know how to check for infinity"
#endif /* __has_builtin(__builtin_isfinite) */
# 60 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"
#define crt_isinf(x) __builtin_isinf((x))
#define crt_isnan(x) __builtin_isnan((x))
#endif /* _MSC_VER */
# 63 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"

#if defined(_MSC_VER) && !defined(__clang__)
#define crt_copysign(x, y) copysign((x), (y))
#define crt_copysignf(x, y) copysignf((x), (y))
#define crt_copysignl(x, y) copysignl((x), (y))
#else
# 69 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"
#define crt_copysign(x, y) __builtin_copysign((x), (y))
#define crt_copysignf(x, y) __builtin_copysignf((x), (y))
#define crt_copysignl(x, y) __builtin_copysignl((x), (y))
#endif
# 73 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"

#if defined(_MSC_VER) && !defined(__clang__)
#define crt_fabs(x) fabs((x))
#define crt_fabsf(x) fabsf((x))
#define crt_fabsl(x) fabs((x))
#else
# 79 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"
#define crt_fabs(x) __builtin_fabs((x))
#define crt_fabsf(x) __builtin_fabsf((x))
#define crt_fabsl(x) __builtin_fabsl((x))
#endif
# 83 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"

#if defined(_MSC_VER) && !defined(__clang__)
#define crt_fmax(x, y) __max((x), (y))
#define crt_fmaxf(x, y) __max((x), (y))
#define crt_fmaxl(x, y) __max((x), (y))
#else
# 89 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"
#define crt_fmax(x, y) __builtin_fmax((x), (y))
#define crt_fmaxf(x, y) __builtin_fmaxf((x), (y))
#define crt_fmaxl(x, y) __builtin_fmaxl((x), (y))
#endif
# 93 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"

#if defined(_MSC_VER) && !defined(__clang__)
#define crt_logb(x) logb((x))
#define crt_logbf(x) logbf((x))
#define crt_logbl(x) logbl((x))
#else
# 99 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"
#define crt_logb(x) __builtin_logb((x))
#define crt_logbf(x) __builtin_logbf((x))
#define crt_logbl(x) __builtin_logbl((x))
#endif
# 103 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"

#if defined(_MSC_VER) && !defined(__clang__)
#define crt_scalbn(x, y) scalbn((x), (y))
#define crt_scalbnf(x, y) scalbnf((x), (y))
#define crt_scalbnl(x, y) scalbnl((x), (y))
#else
# 109 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"
#define crt_scalbn(x, y) __builtin_scalbn((x), (y))
#define crt_scalbnf(x, y) __builtin_scalbnf((x), (y))
#define crt_scalbnl(x, y) __builtin_scalbnl((x), (y))
#endif
# 113 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"

#endif /* INT_MATH_H */
# 115 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/int_math.h"
# 17 "/Users/buildslave/jenkins/sharedspace/phase1@2/llvm/projects/compiler-rt/lib/builtins/mulsc3.c" 2

/* Returns: the product of a + ib and c + id */

COMPILER_RT_ABI Fcomplex
__mulsc3(float __a, float __b, float __c, float __d)
{
    float __ac = __a * __c;
    float __bd = __b * __d;
    float __ad = __a * __d;
    float __bc = __b * __c;
    Fcomplex z;
    COMPLEX_REAL(z) = __ac - __bd;
    COMPLEX_IMAGINARY(z) = __ad + __bc;
    if (crt_isnan(COMPLEX_REAL(z)) && crt_isnan(COMPLEX_IMAGINARY(z)))
    {
        int __recalc = 0;
        if (crt_isinf(__a) || crt_isinf(__b))
        {
            __a = crt_copysignf(crt_isinf(__a) ? 1 : 0, __a);
            __b = crt_copysignf(crt_isinf(__b) ? 1 : 0, __b);
            if (crt_isnan(__c))
                __c = crt_copysignf(0, __c);
            if (crt_isnan(__d))
                __d = crt_copysignf(0, __d);
            __recalc = 1;
        }
        if (crt_isinf(__c) || crt_isinf(__d))
        {
            __c = crt_copysignf(crt_isinf(__c) ? 1 : 0, __c);
            __d = crt_copysignf(crt_isinf(__d) ? 1 : 0, __d);
            if (crt_isnan(__a))
                __a = crt_copysignf(0, __a);
            if (crt_isnan(__b))
                __b = crt_copysignf(0, __b);
            __recalc = 1;
        }
        if (!__recalc && (crt_isinf(__ac) || crt_isinf(__bd) ||
                          crt_isinf(__ad) || crt_isinf(__bc)))
        {
            if (crt_isnan(__a))
                __a = crt_copysignf(0, __a);
            if (crt_isnan(__b))
                __b = crt_copysignf(0, __b);
            if (crt_isnan(__c))
                __c = crt_copysignf(0, __c);
            if (crt_isnan(__d))
                __d = crt_copysignf(0, __d);
            __recalc = 1;
        }
        if (__recalc)
        {
            COMPLEX_REAL(z) = CRT_INFINITY * (__a * __c - __b * __d);
            COMPLEX_IMAGINARY(z) = CRT_INFINITY * (__a * __d + __b * __c);
        }
    }
    return z;
}
